
spool x060_emp_ext_tab_run_demo.lst


select to_char(sysdate, 'dd-mm-yyyy hh24:mi:ss') Date_Time_Start from dual;


prompt
prompt
prompt Execute x060_emp_ext_tab_run_demo.sql


prompt
prompt
prompt Show directory settings

select         owner                   owner
     ,         directory_name          directory_name
     , substr (directory_path, 1, 100) directory_path
from   all_directories
/


prompt
prompt
prompt Restore the original external table files
--     Note:
--     H: is a mapping to my personal directory on the network.
--     G: is a mapping to the server's output directory, via the network.
--     You can adapt these to your own personal situation.

host copy H:\oracle\work\x010_dept_ext_tab.csv g:\dept_ext_tab.csv

-- x011: file contains only comma-separated data
-- host copy H:\oracle\work\x011_emp_ext_tab.csv  g:\emp_ext_tab.csv

-- x012: file contains headerrow and comma-separated data
host copy H:\oracle\work\x012_emp_ext_tab.csv  g:\emp_ext_tab.csv


prompt
prompt
prompt Create (or replace) the external tables

@@x020_dept_ext_tab.tab
@@x021_emp_ext_tab.tab


prompt
prompt
prompt Do a simple select (order by deptno and empno)

select   e.rownumber
       , e.empno
       , e.ename
       , e.job
       , e.mgr
       , to_char(e.hiredate,'dd-MON-yyyy')  hiredate
       , e.sal
       , e.comm
       , e.deptno
       , d.dname
       , d.loc
from     emp_ext_tab   e
       , dept_ext_tab  d
where    e.deptno = d.deptno
order by e.deptno
       , e.empno
/


prompt
prompt
prompt See what happens when we try to perform an update on an external table
prompt

update emp_ext_tab
set    sal    = 750
where  empno  = 7976
/


prompt
prompt
prompt See what happens when we try to add a self key on the 
prompt mgr - empno relation in the emp external table
prompt

alter table emp_ext_tab add
( constraint emp_ext_tab_self_key foreign key (MGR)
  references emp_ext_tab (EMPNO)
)
/


prompt
prompt
prompt See what happens when we try to add a foreign key on
prompt the emp external table (emp.deptno to dept.deptno)
prompt

alter table emp_ext_tab add
( constraint emp_ext_tab_foreign_key foreign key (DEPTNO)
  references dept_ext_tab (DEPTNO)
)
/


prompt
prompt
prompt Create or replace the view on the external table

@@x031_emp_ext_tab_vw.vw


prompt
prompt
prompt Create or replace the DML-package used by the triggers

@@x041_emp_ext_tab_dml.pck


prompt
prompt
prompt Create or replace the INSTEAD OF triggers on the external table view

@@x051a_emp_ext_tab_vw_brd.trg
@@x051b_emp_ext_tab_vw_bri.trg
@@x051c_emp_ext_tab_vw_bru.trg


prompt
prompt
prompt Start doing some DML. After each operation, we show the contents of
prompt the table via a select on the table, ordered ascending on rownumber.
prompt
prompt First, perform a single insert

declare
  --
  l_max_empno   emp_ext_tab.empno%type;
  --
begin
  --
  select max(empno)
  into   l_max_empno
  from   emp_ext_tab_vw;
  --
  insert into emp_ext_tab_vw
  ( empno
  , ename
  , job
  , mgr
  , hiredate
  , sal
  , comm
  , deptno
  )
  values
  ( l_max_empno + 1
  , 'NewInsert'
  , 'clerk'
  , 7788
  , trunc(sysdate,'month')
  , 700
  , to_number(null)
  , 20
  );
  --
end;
/


prompt
prompt
prompt Show tablecontents

@@x062_emp_ext_tab_show_data.sql


prompt
prompt
prompt Perform a select on the table, showing all employees with a salary <= 1250.
prompt Pay attention to the difference between the rownumbers from this select and
prompt the rownumbers from the external table.

select   rownum     rownum_this_select
       , rownumber  rownumber_table
       , empno
       , ename
       , job
       , mgr
       , to_char(hiredate,'dd-MON-yyyy')  hiredate
       , sal
       , comm
       , deptno
from     emp_ext_tab
where    sal <= 1250
order by rownumber asc
/


prompt
prompt
prompt Perform a multiple insert using these records in a "select into" construction

insert into emp_ext_tab_vw
( empno
, ename
, job
, mgr
, hiredate
, sal
, comm
, deptno
)
select empno + 100
     , ename
     , job
     , mgr
     , hiredate
     , sal
     , comm
     , deptno
from   emp_ext_tab_vw
where  sal <= 1250
/


prompt
prompt
prompt Show tablecontents

@@x062_emp_ext_tab_show_data.sql


prompt
prompt
prompt Perform a delete on the first row in the file (empno = 7369)

delete
from   emp_ext_tab_vw
where  empno = 7369
/


prompt
prompt
prompt Show tablecontents

@@x062_emp_ext_tab_show_data.sql


prompt
prompt
prompt Perform a delete on the last row in the file (empno = 7977)

delete
from   emp_ext_tab_vw
where  empno = 7977
/


prompt
prompt
prompt Show tablecontents

@@x062_emp_ext_tab_show_data.sql


prompt
prompt
prompt Perform a delete in the middle of the file (empno = 7844)

delete
from   emp_ext_tab_vw
where  empno = 7844
/


prompt
prompt
prompt Show tablecontents

@@x062_emp_ext_tab_show_data.sql


prompt
prompt
prompt Try to delete that same line again

delete
from   emp_ext_tab_vw
where  empno = 7844
/


prompt
prompt
prompt Show tablecontents

@@x062_emp_ext_tab_show_data.sql


prompt
prompt
prompt Perform a multiple delete: all rows for which comm > 0

delete
from   emp_ext_tab_vw
where  comm > 0
/


prompt
prompt
prompt Show tablecontents

@@x062_emp_ext_tab_show_data.sql


prompt
prompt
prompt Note that multiple deletes from one statement are NOT processed correctly !
prompt The DML-statement determines the rownumbers to delete at the statement level,
prompt not at the row level. This means that, after the first record has been deleted,
prompt the rownumbers, issued by the DML-statement for the records that are to be
prompt deleted, no longer correspond with the actual record-linenumbers in the file.
prompt Thus, the wrong records get deleted.


prompt
prompt
prompt Perform a single update on the sal column for rownumber = 4

update emp_ext_tab_vw
set    sal = sal + 50
where  rownumber = 4
/


prompt
prompt
prompt Show tablecontents

@@x062_emp_ext_tab_show_data.sql


prompt
prompt
prompt Perform a multiple update on the sal column for all rownumber >= 5

update emp_ext_tab_vw
set    sal = sal + 100
where  rownumber >= 5
/


prompt
prompt
prompt Show tablecontents

@@x062_emp_ext_tab_show_data.sql


prompt
prompt
prompt Which constraints does Oracle implement in standard mode ?
prompt Lets perform various (single record) updates to check this out.
prompt
prompt Perform an update on the sal column (new value = 1234567.89) for empno = 7976

update emp_ext_tab_vw
set    sal    = 1234567.89
where  empno  = 7976
/


prompt
prompt
prompt Perform an update on the sal column (new value is null) for empno = 7976

update emp_ext_tab_vw
set    sal    = to_number(null)
where  empno  = 7976
/


prompt
prompt
prompt Perform an update on the deptno column (new value = 123) for empno = 7976

update emp_ext_tab_vw
set    deptno = 123
where  empno  = 7976
/


prompt
prompt
prompt Perform an update on the job column (new value = 'Oracle developer') for empno = 7976

update emp_ext_tab_vw
set    job    = 'Oracle developer'
where  empno  = 7976
/


prompt
prompt
prompt Show tablecontents

@@x062_emp_ext_tab_show_data.sql



prompt
prompt
prompt Note that various database constraints (e.g. null/not null,
prompt allowable values, business rules) and referential integrity
prompt need to be checked and maintained by the programmer.


select to_char(sysdate, 'dd-mm-yyyy hh24:mi:ss') Date_Time_End from dual;

spool off
